Ruby: pm_call_operator_write_node Struct Reference

Ruby 4.0.5p0 (2026-05-20 revision 64336ffd0ee9e1f4c05891695a3d7b49cb709721)

Data Fields
pm_call_operator_write_node Struct Reference

CallOperatorWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_node * | receiver
| CallOperatorWriteNode#receiver.
pm_location_t | call_operator_loc
| CallOperatorWriteNode#call_operator_loc.
pm_location_t | message_loc
| CallOperatorWriteNode#message_loc.
pm_constant_id_t | read_name
| CallOperatorWriteNode#read_name.
pm_constant_id_t | write_name
| CallOperatorWriteNode#write_name.
pm_constant_id_t | binary_operator
| CallOperatorWriteNode#binary_operator.
pm_location_t | binary_operator_loc
| CallOperatorWriteNode#binary_operator_loc.
struct pm_node * | value
| CallOperatorWriteNode#value.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

CallOperatorWriteNode.

Represents the use of an assignment operator on a call.

    foo.bar += baz
    ^^^^^^^^^^^^^^

Type: ::PM_CALL_OPERATOR_WRITE_NODE

Flags (#pm_call_node_flags):

- ::PM_CALL_NODE_FLAGS_SAFE_NAVIGATION
- ::PM_CALL_NODE_FLAGS_VARIABLE_CALL
- ::PM_CALL_NODE_FLAGS_ATTRIBUTE_WRITE
- ::PM_CALL_NODE_FLAGS_IGNORE_VISIBILITY

Definition at line 2264 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_call_operator_write_node::base

The embedded base node.

Definition at line 2266 of file ast.h.

Referenced by pm_dump_json().

## ◆ binary_operator

pm_constant_id_t pm_call_operator_write_node::binary_operator

CallOperatorWriteNode#binary_operator.

Represents the binary operator being used.

    foo.bar += value # binary_operator `:+`
            ^

Definition at line 2327 of file ast.h.

Referenced by pm_dump_json().

## ◆ binary_operator_loc

pm_location_t pm_call_operator_write_node::binary_operator_loc

CallOperatorWriteNode#binary_operator_loc.

Represents the location of the binary operator.

    foo.bar += value
            ^^

Definition at line 2337 of file ast.h.

Referenced by pm_dump_json().

## ◆ call_operator_loc

pm_location_t pm_call_operator_write_node::call_operator_loc

CallOperatorWriteNode#call_operator_loc.

Represents the location of the call operator.

    foo.bar += value
       ^

Definition at line 2287 of file ast.h.

Referenced by pm_dump_json().

## ◆ message_loc

pm_location_t pm_call_operator_write_node::message_loc

CallOperatorWriteNode#message_loc.

Represents the location of the message.

    foo.bar += value
        ^^^

Definition at line 2297 of file ast.h.

Referenced by pm_dump_json().

## ◆ read_name

pm_constant_id_t pm_call_operator_write_node::read_name

CallOperatorWriteNode#read_name.

Represents the name of the method being called.

    foo.bar += value # read_name `:bar`
        ^^^

Definition at line 2307 of file ast.h.

Referenced by pm_dump_json().

## ◆ receiver

struct pm_node* pm_call_operator_write_node::receiver

CallOperatorWriteNode#receiver.

The object that the method is being called on. This can be either nil or any non-void expressions.

    foo.bar += value
    ^^^

Definition at line 2277 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ value

struct pm_node* pm_call_operator_write_node::value

CallOperatorWriteNode#value.

Represents the value being assigned.

    foo.bar += value
               ^^^^^

Definition at line 2347 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ write_name

pm_constant_id_t pm_call_operator_write_node::write_name

CallOperatorWriteNode#write_name.

Represents the name of the method being written to.

    foo.bar += value # write_name `:bar=`
        ^^^

Definition at line 2317 of file ast.h.

Referenced by pm_dump_json().

The documentation for this struct was generated from the following file:

- prism/ast.h